package mfa

import (
	"boss/internal/utils"
	"bytes"
	"encoding/base64"
	"fmt"
	"net/url"
	"strconv"
	"time"

	"github.com/skip2/go-qrcode"
	"github.com/xlzd/gotp"
)

const secretLength = 16

type Otp struct {
	Secret  string `json:"secret"`
	QrImage string `json:"qrImage"`
	Key     string `json:"key"`
}

func GetOtp(userId, username, secret, key string) (otp Otp, err error) {
	if secret == "" {
		secret = gotp.RandomSecret(secretLength)
		key = utils.RandomString(6)
	}
	otp.Secret = secret
	totp := gotp.NewDefaultTOTP(secret)
	uri := totp.ProvisioningUri(userId, fmt.Sprintf("卡销平台 管理员 %s %s", username, key))
	uri, err = url.PathUnescape(uri)
	if err != nil {
		return
	}
	subImg, err := qrcode.Encode(uri, qrcode.Medium, 256)
	dist := make([]byte, 3000)
	base64.StdEncoding.Encode(dist, subImg)
	index := bytes.IndexByte(dist, 0)
	baseImage := dist[0:index]
	otp.QrImage = "data:image/png;base64," + string(baseImage)
	otp.Key = key
	return
}

func ValidCode(code string, secret string) bool {
	totp := gotp.NewDefaultTOTP(secret)
	now := time.Now().Unix()
	strInt64 := strconv.FormatInt(now, 10)
	id16, _ := strconv.Atoi(strInt64)
	return totp.Verify(code, int64(id16))
}
